Index: kern/uipc_usrreq.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/uipc_usrreq.c,v
retrieving revision 1.143
diff -u -r1.143 uipc_usrreq.c
--- kern/uipc_usrreq.c	1 Dec 2004 09:22:26 -0000	1.143
+++ kern/uipc_usrreq.c	19 Dec 2004 03:22:50 -0000
@@ -452,7 +452,9 @@
 			}
 		}
 
+		SOCKBUF_LOCK(&so->so_snd);
 		if (so->so_snd.sb_state & SBS_CANTSENDMORE) {
+			SOCKBUF_UNLOCK(&so->so_snd);
 			error = EPIPE;
 			break;
 		}
@@ -478,6 +480,7 @@
 		    (so2->so_rcv.sb_cc - unp->unp_conn->unp_cc);
 		(void)chgsbsize(so->so_cred->cr_uidinfo, &so->so_snd.sb_hiwat,
 		    newhiwat, RLIM_INFINITY);
+		SOCKBUF_UNLOCK(&so->so_snd);
 		unp->unp_conn->unp_cc = so2->so_rcv.sb_cc;
 		sorwakeup_locked(so2);
 		m = NULL;

